/*
 * Created on May 12, 2004
 */
package eShopper;

/**
 * This is an Ingredient that is in the database, but doesn't need
 * the information associated with being in a recipe or a shopping list.
 * 
 * @author Adam
 *
 */
public class Ingredient {
	
	String myName;
	int ingredientID;
	
	public Ingredient(int ID, String name){
		ingredientID = ID;
		myName = name;
	}
	
	/**
	 * This is a getter method for the IngredientID.
	 * 
	 * @return The ID of the ingredient.
	 */
	public int getID() {
		return ingredientID;
	}
	
	/**
	 * This is a getter method for the ingredient's name.
	 * 
	 * @return The name of the ingredient.
	 */
	public String getName(){
		return myName;
	}
	
	/**
	 * This sets the Ingredient's name to the given name.
	 * @param newName The name the Ingredient should have.
	 */
	public void setName(String newName){
		myName = newName;
	}
	
	/**
	 * This implements the toString method and returns the name of
	 * the ingredient.
	 */
	public String toString(){
		return myName;
	}
}
