package eShopper;

import java.util.Vector;

/*
 * Created on Apr 26, 2004
 *
 */

/**
 * An abstract class to specify the functions and attributes common 
 * to all of the nodes on our eShopperList. Subclassed by eShopperRoot,
 * eShopperDate, eShopperRecipe, and eShopperIngredient.
 * 
 * @author Jim Laing
 *
 */
public abstract class eShopperNode {
	eShopperDB db;
	int listID, nodeID;
	
	/**
	 * Gets a vector of children 
	 * @return the children of a node
	 */
	public abstract Vector getChildren();
	
	/**
	 * Gets the String which is used to represent the node in a JTree
	 * @return a String representation of a node
	 */
	public abstract String toString();
	
	/**
	 * Returns any date associated with this node (i.e. any date ancestor)
	 * @return a string representation of the date
	 */
	public abstract String getDate();
	
	/**
	 * Used to get the unique ID of list items
	 * @return an int, the database of the node if it is a recipe or ingredient, 
	 * otherwise 0
	 */
	public abstract int nodeID();
}
